<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTipoContactosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTipoContactosERP
 * @subpackage Arrays
 */
class ArrayOfTipoContactosERP extends AbstractStructArrayBase
{
    /**
     * The TipoContactosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipoContactosERP[]
     */
    public $TipoContactosERP;
    /**
     * Constructor method for ArrayOfTipoContactosERP
     * @uses ArrayOfTipoContactosERP::setTipoContactosERP()
     * @param \StructType\TipoContactosERP[] $tipoContactosERP
     */
    public function __construct(array $tipoContactosERP = array())
    {
        $this
            ->setTipoContactosERP($tipoContactosERP);
    }
    /**
     * Get TipoContactosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipoContactosERP[]|null
     */
    public function getTipoContactosERP()
    {
        return isset($this->TipoContactosERP) ? $this->TipoContactosERP : null;
    }
    /**
     * Set TipoContactosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TipoContactosERP[] $tipoContactosERP
     * @return \ArrayType\ArrayOfTipoContactosERP
     */
    public function setTipoContactosERP(array $tipoContactosERP = array())
    {
        foreach ($tipoContactosERP as $arrayOfTipoContactosERPTipoContactosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfTipoContactosERPTipoContactosERPItem instanceof \StructType\TipoContactosERP) {
                throw new \InvalidArgumentException(sprintf('The TipoContactosERP property can only contain items of \StructType\TipoContactosERP, "%s" given', is_object($arrayOfTipoContactosERPTipoContactosERPItem) ? get_class($arrayOfTipoContactosERPTipoContactosERPItem) : gettype($arrayOfTipoContactosERPTipoContactosERPItem)), __LINE__);
            }
        }
        if (is_null($tipoContactosERP) || (is_array($tipoContactosERP) && empty($tipoContactosERP))) {
            unset($this->TipoContactosERP);
        } else {
            $this->TipoContactosERP = $tipoContactosERP;
        }
        return $this;
    }
    /**
     * Add item to TipoContactosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\TipoContactosERP $item
     * @return \ArrayType\ArrayOfTipoContactosERP
     */
    public function addToTipoContactosERP(\StructType\TipoContactosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TipoContactosERP) {
            throw new \InvalidArgumentException(sprintf('The TipoContactosERP property can only contain items of \StructType\TipoContactosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TipoContactosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TipoContactosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TipoContactosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TipoContactosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TipoContactosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TipoContactosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TipoContactosERP
     */
    public function getAttributeName()
    {
        return 'TipoContactosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTipoContactosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
